//---------------------------------------------------------------------------
#include <iostream.h>
#include <math.h>
//---------------------------------------------------------------------------
float CDF(float x);
//---------------------------------------------------------------------------
int main()
{
    float r,delta,sigma;
    float S0,K;
    float y_p,y_m;
    float T,t=0;
    float CT,PT;

    //Entering of the task parameters
    cout<<"Enter initial asset price ";cin>>S0;
    cout<<"Enter execution price of the contract ";cin>>K;
    cout<<"Enter bond interest rate ";cin>>r;
    cout<<"Enter dividend interest rate ";cin>>delta;
    cout<<"Enter value of volatility ";cin>>sigma;
    cout<<"Expiration moment ";cin>>T;

//    r=0.1;sigma=0.8;S0=100;K=80;T=0.589;delta=0.1;

    //Evaluation of the option call and the option put price
    y_p=(log(S0/K)+(T-t)*(r-delta+0.5*pow(sigma,2)))/(sigma*sqrt(T));
    y_m=(log(S0/K)+(T-t)*(r-delta-0.5*pow(sigma,2)))/(sigma*sqrt(T));

    CT=S0*exp(-delta*T)*CDF(y_p)-K*exp(-r*T)*CDF(y_m);
    cout<<"Option call price is "<<CT<<endl;
    PT=CT-S0*exp(-delta*T)+K*exp(-r*T);
    cout<<"Option put price is "<<PT<<endl;

    return 0;
}
//---------------------------------------------------------------------------
//Cumulative distribution function
float CDF(float x)
{
    float sum=0;
    float step=0.001;

    if(x<-4){return 0;}
    if(x>4){return 1;}

    for(float i=-4+step;i<=x;i+=step){
        sum+=exp(-0.5*pow((i-0.5*step),2))*step;
    }
    return sum/sqrt(2*M_PI);
}

