//---------------------------------------------------------------------------
#include <iostream.h>
#include <math.h>
//---------------------------------------------------------------------------
float CDF(float x);
//---------------------------------------------------------------------------
int main()
{
    float r,sigma;
    float S0,K,St;
    float y_p,y_m;
    float T,t;
    float CT,PT,theta,delta,rho,vega;

    //Entering of the data for evaluation
    cout<<"Enter initial asset price ";cin>>S0;
    cout<<"Enter execution price of the contract ";cin>>K;
    cout<<"Enter bond interest rate ";cin>>r;
    cout<<"Enter value of volatility ";cin>>sigma;
    cout<<"Expiration moment ";cin>>T;

    //Evaluation of the option call and option put prices
    CT=S0*CDF((log(S0/K)+T*(r+0.5*pow(sigma,2)))/(sigma*sqrt(T)))-K*exp(-r*T)*CDF((log(S0/K)+T*(r-0.5*pow(sigma,2)))/(sigma*sqrt(T)));
    cout<<"\n\nOption call price is "<<CT<<endl;
    PT=CT-S0+K*exp(-r*T);
    cout<<"Option put price is "<<PT<<endl;

    //Evaluation of the Greek market parameters
    cout<<"\n\nEnter time parameter t=";cin>>t;
    cout<<"Entet asset price at this moment of time St=";cin>>St;

    y_p=(log(St/K)+(T-t)*(r+0.5*pow(sigma,2)))/(sigma*sqrt(T-t));
    y_m=(log(St/K)+(T-t)*(r-0.5*pow(sigma,2)))/(sigma*sqrt(T-t));

    theta=(St*sigma*exp(-0.5*pow(y_p,2)))/(2*sqrt(2*M_PI*(T-t)))-K*r*exp(-r*T)*CDF(-y_m);
    delta=CDF(y_p);
    rho=K*(T-t)*exp(-r*(T-t))*CDF(y_m);
    vega=(St*exp(-0.5*pow(y_p,2))*sqrt(T-t))/sqrt(2*M_PI);

    cout<<"\n\nGreek parameters of the market\n";
    cout<<"Theta="<<theta<<endl;
    cout<<"Delta="<<delta<<endl;
    cout<<"Rho="<<rho<<endl;
    cout<<"Vega="<<vega<<endl;

    return 0;
}
//---------------------------------------------------------------------------
// Cumulative distribution function
float CDF(float x)
{
    float sum=0;
    float step=0.001;

    if(x<-4){return 0;}
    if(x>4){return 1;}

    for(float i=-4+step;i<=x;i+=step){
        sum+=exp(-0.5*pow((i-0.5*step),2))*step;
    }
    return sum/sqrt(2*M_PI);
}

