//---------------------------------------------------------------------------
#include <iostream.h>
#include <math.h>
//---------------------------------------------------------------------------
float B(int k0, int N, float p);
//---------------------------------------------------------------------------
int main()
{
    float rho1,rho2,r; //profitabilities of the stock and bank interest rate
    int N,k0;          //Terminal moment of time, start point for B-function
    float S0,K;        //Initial price of the stock, Execution price of the contract
    float CN,PN;       //Price of the call-option, Price of the put-option
    float p_star,p_wave; //risk-neutral probability, derivation probability

    cout<<"Enter initial price of the asset\n";
    cout<<"S0=";cin>>S0;
    cout<<"Enter execution price of the contract"<<endl;
    cout<<"K=";cin>>K;
    cout<<"Enter profitabilities of asset\n";
    cout<<"b=";cin>>rho1;
    cout<<"a=";cin>>rho2;
    cout<<"Enter interest rate of the bond\n";
    cout<<"r=";cin>>r;
    cout<<"Enter horizon of prediction\n";
    cout<<"N=";cin>>N;

    //Evaluation of the risk-neutral probability and the auxliary value
    p_star=(r-rho2)/(rho1-rho2);
    p_wave=p_star*(1+rho1)/(1+r);

    //Evaluation of start point for the B-function
    k0=floor(log(K/(S0*pow(1+rho2,N)))/log((1+rho1)/(1+rho2)))+1;

    cout<<"Risk neutral probability p*="<<p_star<<endl;

//    printf("B(%d,%d,%f)=%f\n",k0,N,p_wave,B(k0,N,p_wave));
//    printf("B(%d,%d,%f)=%f\n",k0,N,p_star,B(k0,N,p_star));

    //evaluation of the option call price
    CN=S0*B(k0,N,p_wave)-K*B(k0,N,p_star)/pow(1+r,N);

    //evaluation of the option put price
    PN=CN-S0+K/pow(1+r,N);

    cout<<"Price of option call C="<<CN<<endl;
    cout<<"Price of option put P="<<PN<<endl;

    return 0;
}
//---------------------------------------------------------------------------

float B(int k0, int N, float p)
{
    float sum=0;

    for(int j=k0;j<=N;j++){
        int Nf=1,kf=1,Nkf=1;
        for(int i=N;i>=1;i--){Nf*=i;}
        for(int i=j;i>=1;i--){kf*=i;}
        for(int i=N-j;i>=1;i--){Nkf*=i;}
//        printf("%d,%d,%d\n",Nf,kf,Nkf);

        sum+=Nf*pow(p,j)*pow(1-p,N-j)/(kf*Nkf);
    }
    return sum;
}

