//---------------------------------------------------------------------------
//This script evaluates some indicators, included into standard technical
//analysis. There are:
//1.  Simple moving average
//2.  Wheighted moving average
//3.  Exponential moving average
//4.  Bollinger Bands
//5.  MACD - Moving Average Convergence/Divergence
//6.  RSI  - Relative Strength Index
//7.  PTP  - Parabolic Time Price system
//8.  VPT  - Volume Price Trend

#include <iostream.h>
#include <fstream.h>
#include <math.h>

#define max(a, b)  (((a) > (b)) ? (a) : (b))
//---------------------------------------------------------------------------
int main()
{
    int choice;

    cout<<"1.  Simple moving average\n";
    cout<<"2.  Wheighted moving average\n";
    cout<<"3.  Exponential moving average\n";
    cout<<"4.  Bollinger Bands\n";
    cout<<"5.  MACD - Moving Average Convergence/Divergence\n";
    cout<<"6.  RSI  - Relative Strength Index\n";
    cout<<"7.  PTP  - Parabolic Time Price System\n";
    cout<<"8.  VPT  - Volume Price Trend\n\n";
    cout<<"Enter number of indicator for evaluation - ";
    cin>>choice;
    if(choice==1){
        cout<<"You choosed evaluation of the simple moving average\n";

        ifstream dataf;     //datafile
        ofstream pricesf;   //output data for prices plotting
        ofstream maf;       //output data for the indicator plotting

        float aux;
        int n;              //order of the moving average
        int xpoint=0;
        float ma;           //value of the moving average

        cout<<"Enter the order of the Moving Average - ";
        cin>>n;
        float *marray = new float[n];

        dataf.open("data.txt");
        pricesf.open("prices");
        maf.open("ma");

        cout<<"Please wait...\n";
        while(dataf>>aux){
            xpoint++;
            pricesf<<xpoint<<" "<<aux<<endl;

            //filling of array containes last n values
            if(xpoint<=n){marray[xpoint-1]=aux;}
            else{
                for(int i=0;i<n-1;i++){marray[i]=marray[i+1];}
                marray[n-1]=aux;
            }
            if(xpoint<n){continue;}

            //evaluation of moving average
            ma=0;
            for(int i=0;i<n;i++){ma+=marray[i];}
            ma/=n;
            maf<<xpoint<<" "<<ma<<endl;
        }
    }
    if(choice==2){
        cout<<"You choosed evaluation of the Weighted Moving Average\n";

        ifstream dataf;     //datafile
        ofstream pricesf;   //output data for prices plotting
        ofstream wmaf;       //output data for the indicator plotting

        float aux;
        int n;              //order of the moving average
        int xpoint=0;
        float wma;          //value of the weighted moving average

        cout<<"Enter the order of the moving average - ";
        cin>>n;
        float *marray = new float[n];
        float *weight = new float[n];
        float sum=n*(n+1)/2;

        //Evaluation of the weights for MA evaluation
        for(int i=0;i<n;i++){weight[i]=(i+1)/sum;}

        dataf.open("data.txt");
        pricesf.open("prices");
        wmaf.open("wma");

        cout<<"Please wait...\n";
        while(dataf>>aux){
            xpoint++;
            pricesf<<xpoint<<" "<<aux<<endl;

            //filling of the array containing last n values
            if(xpoint<=n){marray[xpoint-1]=aux;}
            else{
                for(int i=0;i<n-1;i++){marray[i]=marray[i+1];}
                marray[n-1]=aux;
            }
            if(xpoint<n){continue;}

            //Evaluation of the weighted moving average
            wma=0;
            for(int i=0;i<n;i++){wma+=marray[i]*weight[i];}
            wmaf<<xpoint<<" "<<wma<<endl;
        }
    }
    if(choice==3){
        cout<<"You choosed evaluation of the Exponential Moving Average\n";

        ifstream dataf;     //datafile
        ofstream pricesf;   //output data for prices plotting
        ofstream emaf;      //output data for the indicator plotting

        float aux;
        int n;              //order of the moving average
        int xpoint=0;
        float ema;          //value of the moving average

        cout<<"Enter the order of the moving average - ";
        cin>>n;
        float alpha=2.0/(n+1);

        dataf.open("data.txt");
        pricesf.open("prices");
        emaf.open("ema");

        cout<<"Please wait...\n";
        while(dataf>>aux){
    	    xpoint++;
            pricesf<<xpoint<<" "<<aux<<endl;

            if(xpoint==1){
	        ema=aux;
	        continue;
            }

            //evaluation of the expontial moving average
            ema=alpha*aux+(1-alpha)*ema;

            emaf<<xpoint<<" "<<ema<<endl;
        }
    }
    if(choice==4){
        cout<<"You choosed evaluation of the Bollinger Bands\n";

        ifstream dataf;     //datafile
        ofstream pricesf;   //output data for prices plotting
        ofstream bbandsf;   //output data for the indicator plotting

        float aux;
        int n;              //order of the moving average
        int xpoint=0;
        float ema;          //value of the weighted moving average
	    float dev;          //value of the standard deviation
    	float k;            //value of the standard deviation coefficient

        cout<<"Enter the order of the moving average - ";
        cin>>n;
    	cout<<"Enter the multiplier for the standard deviation (3 is recommended) - ";
	    cin>>k;
        float *marray = new float[n];  //array of the n last values
        float alpha=2.0/(n+1);

	cout<<"Please wait...\n";
        dataf.open("data.txt");
        pricesf.open("prices");
        bbandsf.open("bbands");
    	while(dataf>>aux){
	        xpoint++;
	        pricesf<<xpoint<<" "<<aux<<endl;

            //filling of array contains last n values
            if(xpoint<=n){marray[xpoint-1]=aux;}
            else{
	            for(int i=0;i<n-1;i++){marray[i]=marray[i+1];}
                marray[n-1]=aux;
            }

    	    if(xpoint==1){
	            ema=aux;
		        continue;
    	    }

            //evaluation of the moving average
    	    ema=alpha*aux+(1-alpha)*ema;

            //If marray is not full do next cycle
            if(xpoint<n){continue;}

            //evaluation of the standard deviation
    	    dev=0;
	        for(int i=0;i<n;i++){dev+=pow(marray[i]-ema,2);}
	        dev=k*sqrt(dev/n);

    	    bbandsf<<xpoint<<" "<<ema-dev<<" "<<ema+dev<<" "<<ema<<endl;
        }
    }
    if(choice==5){
        cout<<"You choosed evaluation of the MACD indicator\n";

    	ifstream dataf;
	    ofstream pricesf;
    	ofstream macdf;

	    float aux;
    	float fastline;
    	int xpoint;
    	int n1,n2,n3; //orders of the averages for the signal evaluation;
    	float ema1,ema2,ema3; //ema1 - short, ema2 - long, ema3 - average of ema1-ema2
    	cout<<"Enter order of the short EMA (recommended 12) - ";
    	cin>>n1;
    	cout<<"Enter order of the long EMA (recommended 26) - ";
    	cin>>n2;
    	cout<<"Enter order of the fast line averaging (recommended 9) - ";
    	cin>>n3;

	    float alpha1=2.0/(n1+1);
    	float alpha2=2.0/(n2+1);
    	float alpha3=2.0/(n3+1);

    	dataf.open("data.txt");
    	pricesf.open("prices");
    	macdf.open("macd");

	    cout<<"Please wait...\n";
    	while(dataf>>aux){
	        xpoint++;
	        pricesf<<xpoint<<" "<<aux<<endl;

    	    if(xpoint==1){
	            ema1=aux;
	    	    ema2=aux;
                continue;
    	    }

	        ema1=alpha1*aux+(1-alpha1)*ema1;
    	    ema2=alpha2*aux+(1-alpha2)*ema2;
	        if(xpoint<n2){continue;}

    	    fastline=ema1-ema2;
    	    if(xpoint==n2){
                ema3=fastline;
                continue;
            }

    	    ema3=alpha3*fastline+(1-alpha3)*ema3;
            if(xpoint<n2+n3){continue;}

    	    macdf<<xpoint<<" "<<fastline-ema3<<endl;
	    }
    }
    if(choice==6){
        cout<<"You choosed RSI index evaluation\n";

    	ifstream dataf;
	    ofstream rsif;
    	ofstream pricesf;

    	float aux;
    	float lprice;
    	int xpoint;
    	float up,down;  //Parameters of up and down increment of the price
    	int n;          //Period of averaging
    	cout<<"Enter the period of averaging - ";
    	cin>>n;

    	dataf.open("data.txt");
    	pricesf.open("prices");
    	rsif.open("rsi");
    	cout<<"Please wait...\n";
    	while(dataf>>aux){
    	    xpoint++;
    	    pricesf<<xpoint<<" "<<aux<<endl;

    	    if(xpoint==1){lprice=aux;}
    	    if(xpoint==2){
    	        up=max(aux-lprice,0)/n;
	        	down=max(lprice-aux,0)/n;
    	    	lprice=aux;
    	    }
    	    if(xpoint<3){continue;}

	        up=(up*(n-1)+max(aux-lprice,0))/n;
       	    down=(down*(n-1)+max(lprice-aux,0))/n;
            lprice=aux;
            if(down==0){continue;}
	        rsif<<xpoint<<" "<<100-100/(1+up/down)<<endl;
    	}
    }
    if(choice==7){
        cout<<"You choosed for the PTP indicator evaluation\n";

    	ifstream dataf;
    	ofstream pricesf;
    	ofstream ptpf;

    	float open,ptp,lastptp;
    	float low,high,close,aux; //high, low and close of the previous bar accordingly
    	int xpoint;
        int direction;
    	float af=0.2,ep;

    	dataf.open("datav.txt");
    	pricesf.open("prices");
    	ptpf.open("ptp");
    	cout<<"Please wait...\n";
    	while(dataf>>open){
            dataf>>low;
            dataf>>high;
            dataf>>close;
            dataf>>aux;  //nuisance parameter

            xpoint++;
            pricesf<<xpoint<<" "<<open<<" "<<low<<" "<<high<<" "<<close<<endl;

            if(xpoint==1){
                if(open>close){
                    direction=-1;
                    ep=low;
                }
                else{
                    direction=1;
                    ep=high;
                }
                lastptp=close+af*(ep-close);
                continue;
            }

            ptp=lastptp+af*(ep-lastptp);
            ptpf<<xpoint<<" "<<ptp<<endl;

            if(lastptp<ptp){direction=1;}
            else{direction=-1;}

            if(direction==1){
                if(ep<high){af+=0.02;}
                if(ep>high){af=0.2;}
                ep=high;
            }
            else{
               if(ep>low){af+=0.02;}
               if(ep<low){af=0.2;}
               ep=low;
            }

            lastptp=ptp;
        }
    }
    if(choice==8){
        cout<<"You choosed for VPT indicator evaluation\n";

        ifstream dataf;
        ofstream pricesf;
        ofstream vptf;

        float price,volume,lastprice,vpt,aux;
        int xpoint;

        dataf.open("datav.txt");
        pricesf.open("prices");
        vptf.open("vpt");
        cout<<"Please wait...\n";
    	while(dataf>>aux){
            dataf>>aux;  //nuisance parameter
	    dataf>>aux;  //nuisance paremeter
	    dataf>>price;
	    dataf>>volume;
	    
            xpoint++;
            pricesf<<xpoint<<" "<<price<<endl;

            if(xpoint==1){lastprice=price;}
            if(xpoint==2){
                vpt=volume*(price-lastprice)/lastprice;
                lastprice=price;
            }
            if(xpoint<3){continue;}
            vpt+=volume*(price-lastprice)/lastprice;
            vptf<<xpoint<<" "<<vpt<<endl;
            lastprice=price;
        }
    }
    return 0;
}
//---------------------------------------------------------------------------

