//---------------------------------------------------------------------------
#include <iostream.h>
#include <fstream.h>
#include <math.h>

#pragma hdrstop

float CDF(float x);
float Quantile(float x);
//---------------------------------------------------------------------------

#pragma argsused
int main()
{
    ifstream dataf;
    float aux;
    float epsilon;
    float a;
    int n,i=-1;
    int Nstr=0,N;
    float EX,SX; //Expectation of X and standard deviation of X
    float premium;

    cout<<"Enter the ruin probability - ";cin>>epsilon;
    a=Quantile(1-epsilon);

    dataf.open("RPIdata.txt");
    while(dataf>>aux){Nstr++;}
    dataf.clear();
    dataf.close();

    cout<<"Enter number of contracts ";cin>>n;
    cout<<"You can make statistics on "<<Nstr-n+1<<" data sets\n";
    cout<<"Enter quantity of sets you want to use for this purpose ";cin>>N;
    
    cout<<"Plese wait...\n";
    
    float *X = new float[n];     //sum of the contract payments
    float *X_ind = new float[N]; //risk process
    dataf.open("RPIdata.txt");
    EX=0;
    while(dataf>>aux){
        i++;
        if(i<n){X[i]=aux;}
        else{
            for(int j=0;j<n-1;j++){X[j]=X[j+1];}
            X[n-1]=aux;
        }
        if(i<n-1){continue;}

        X_ind[i-n+1]=0;
        for(int j=0;j<n;j++){X_ind[i-n+1]+=X[j];}
        EX+=X_ind[i-n+1];
        if(i==N-2+n){break;}
    }
    dataf.clear();
    dataf.close();

    SX=0;
    EX/=N;
    for(int j=0;j<N;j++){SX+=pow(X_ind[j]-EX,2);}
    SX=sqrt(SX/N);

    premium=EX+a*SX;
    cout<<"Aggregate risk premium is "<<premium<<endl;

    return 0;
}
//---------------------------------------------------------------------------
//Quantile
float Quantile(float x)
{
    int denominator=5;
    float precision=0.0001;
    float step=1;
    int direction;
    int prev_dir=0;
    float quantile=0;

    while(step>precision){
        if(x<CDF(quantile)){direction=-1;}
        if(x>CDF(quantile)){direction=1;}

        quantile+=direction*step;
        if(prev_dir==0){
            prev_dir=direction;
            continue;
        }
        if(prev_dir!=direction){step/=denominator;}
        prev_dir=direction;
    }
    return quantile;
}

//Cumulative distribution function
float CDF(float x)
{
    float sum=0;
    float step=0.001;

    if(x<-4){return 0;}
    if(x>4){return 1;}

    for(float i=-4+step;i<=x;i+=step){
        sum+=exp(-0.5*pow((i-0.5*step),2))*step;
    }
    return sum/sqrt(2*M_PI);
}

