//---------------------------------------------------------------------------
#include <iostream.h>
#include <math.h>

float B(int k0, int N, float p);
//---------------------------------------------------------------------------

int main()
{
    float b,a,r;         //profitabilities of the stock and bank interest rate
    int N,k0;            //Terminal moment of time, start point for B-function
    float S0,K;          //Initial price of the stock, Execution price of the contract
    float CN;            //Price of the call-option, Price of the put-option
    float p_star,p_wave; //risk-neutral probability, derivation probability
    float p_x;           //conditional probability to live more then terminal moment

    cout<<"Enter initial price of the asset\n";
    cout<<"S0=";cin>>S0;
    cout<<"Enter execution price of the contract"<<endl;
    cout<<"K=";cin>>K;
    cout<<"Enter profitabilities of the asset\n";
    cout<<"b=";cin>>b;
    cout<<"a=";cin>>a;
    cout<<"Enter interest rate of the bond\n";
    cout<<"r=";cin>>r;
    cout<<"Enter horizon of evaluation\n";
    cout<<"N=";cin>>N;
    cout<<"Enter the probability to go through the age T\n";
    cout<<"p=";cin>>p_x;

    //Evaluation of the risk-neutral probability and the auxliary value
    p_star=(r-a)/(b-a);
    p_wave=p_star*(1+b)/(1+r);

    //Evaluation of start point for the B-function
    k0=floor(log(K/(S0*pow(1+a,N)))/log((1+b)/(1+a)))+1;

    CN=N*p_x*K/pow(1+r,N)+N*p_x*(S0*B(k0,N,p_wave)-K*B(k0,N,p_star)/pow(1+r,N));
    cout<<"The price of the contract is "<<CN<<endl;

    return 0;
}
//---------------------------------------------------------------------------
float B(int k0, int N, float p)
{
    float sum=0;

    for(int j=k0;j<=N;j++){
        int Nf=1,kf=1,Nkf=1;
        for(int i=N;i>=1;i--){Nf*=i;}
        for(int i=j;i>=1;i--){kf*=i;}
        for(int i=N-j;i>=1;i--){Nkf*=i;}
        sum+=Nf*pow(p,j)*pow(1-p,N-j)/(kf*Nkf);
    }
    return sum;
}

