//---------------------------------------------------------------------------
#include <iostream.h>
#include <math.h>
//---------------------------------------------------------------------------
float B(int k0, int N, float p);
//---------------------------------------------------------------------------
int main()
{
    float rho1,rho2,r1,r2;
    int N,k0;
    float S0,K;
    float CNh,CNl;
    float p_star,p_wave;
    float aux;

    cout<<"Enter initial price of the asset\n";
    cout<<"S0=";cin>>S0;
    cout<<"Enter execution price of the contract"<<endl;
    cout<<"K=";cin>>K;
    cout<<"Enter profitabilities of the asset\n";
    cout<<"b=";cin>>rho1;
    cout<<"a=";cin>>rho2;
    cout<<"Enter interest rates of credit and deposit accordingly\n";
    cout<<"r1=";cin>>r1;
    cout<<"r2=";cin>>r2;
    cout<<"Enter horizon of prediction\n";
    cout<<"N=";cin>>N;

    //Evaluation of the upper bound of the spread
    p_star=(r1-rho2)/(rho1-rho2);
    p_wave=p_star*(1+rho1)/(1+r1);
    k0=floor(log(K/(S0*pow(1+rho2,N)))/log((1+rho1)/(1+rho2)))+1;
    cout<<"Risk-neutral probability p*="<<p_star<<endl;
//    printf("B(%d,%d,%f)=%f\n",k0,N,p_wave,B(k0,N,p_wave));
//    printf("B(%d,%d,%f)=%f\n",k0,N,p_star,B(k0,N,p_star));
    CNh=S0*B(k0,N,p_wave)-K*B(k0,N,p_star)/pow(1+r1,N);

    //Evaluation of the lower bound of the spread
    p_star=(r2-rho2)/(rho1-rho2);
    p_wave=p_star*(1+rho1)/(1+r2);
    k0=floor(log(K/(S0*pow(1+rho2,N)))/log((1+rho1)/(1+rho2)))+1;
//    printf("B(%d,%d,%f)=%f\n",k0,N,p_wave,B(k0,N,p_wave));
//    printf("B(%d,%d,%f)=%f\n",k0,N,p_star,B(k0,N,p_star));
    CNl=S0*B(k0,N,p_wave)-K*B(k0,N,p_star)/pow(1+r2,N);

    if(CNl<CNh){
	cout<<"Lowest price of option call CN="<<CNl<<endl;    
	cout<<"Highest price of option call CN="<<CNh<<endl;
	aux=CNh-CNl;
    }
    else{
	cout<<"Lowest price of option call CN="<<CNh<<endl;    
	cout<<"Highest price of option call CN="<<CNl<<endl;
	aux=CNl-CNh;
    }
    cout<<"Spread of this market is "<<aux<<endl;

    return 0;
}
//---------------------------------------------------------------------------

float B(int k0, int N, float p)
{
    float sum=0;

    for(int j=k0;j<=N;j++){
        int Nf=1,kf=1,Nkf=1;
        for(int i=N;i>=1;i--){Nf*=i;}
        for(int i=j;i>=1;i--){kf*=i;}
        for(int i=N-j;i>=1;i--){Nkf*=i;}
//        printf("%d,%d,%d\n",Nf,kf,Nkf);

        sum+=Nf*pow(p,j)*pow(1-p,N-j)/(kf*Nkf);
    }
    return sum;
}

