//---------------------------------------------------------------------------
#include <iostream.h>
#include <fstream.h>
#include <math.h>
//---------------------------------------------------------------------------
float CDF(float x);
float Quantile(float x);
//---------------------------------------------------------------------------
int main()
{
    float aux;
    ifstream dataf;
    int n=0;                //Quantity of the data
    int T;                  //Period for the estimation
    int N;                  //Number of simulations
    int spoint,overlap;     //Start point for the data array, increment of the start point
    float pVAR,pbounds;     //Probabilities of VAR and confidential bound of VAR
    dataf.open("vardata.txt");
    while(dataf>>aux){n++;}
    dataf.clear();
    dataf.close();

    cout<<"You have "<<n<<" returns.\n";
    cout<<"Enter the period for estimation - ";cin>>T;
    cout<<"It is avalible to make "<<n-T<<" simulations.\n";
    cout<<"Enter number of simulations you want to use for evaluation  - ";cin>>N;
    overlap=floor((n-T)/N);
    spoint=n-T-overlap*(N-1)-1;

    cout<<"Please wait...\n";

    float *data = new float[n];
    float *PandL = new float[n-T];

    //collecting of profits and loss statistics
    dataf.open("vardata.txt");
    for(int i=0;i<n;i++){dataf>>data[i];}
    for(int i=0;i<N;i++){
        PandL[i]=data[spoint+T]-data[spoint];
        spoint+=overlap;
    }


    //sorting array by descending
    aux=0;
    int flag=1;
    int iterations=0;
    int delimiter=N-1;
    while(delimiter>1){
        iterations++;
        flag=0;
        for(int i=0;i<delimiter;i++){
            if(PandL[i]<PandL[i+1]){
                aux=PandL[i];
                PandL[i]=PandL[i+1];
                PandL[i+1]=aux;
                flag=1;
            }
        }
        delimiter--;
        if(flag==0){break;}
    }

    int aver; //Number of VAR
    int lower;
    int upper;
    cout<<"Enter VAR percentage (in %) - ";cin>>pVAR;
    cout<<"Enter confidential probability of VAR - ";cin>>pbounds;
    pbounds+=(1-pbounds)/2;
    aver=floor(N*pVAR/100);
    lower=floor(N*pVAR/100-sqrt(N*pVAR*(1-pVAR/100)*Quantile(pbounds)/100));
    upper=ceil((N*pVAR/100)+sqrt(N*pVAR*(1-pVAR/100)*Quantile(pbounds)/100));
    cout<<"VAR is    "<<fabs(PandL[lower])<<" < "<<fabs(PandL[aver])<<" < "<<fabs(PandL[upper])<<endl;

    return 0;

}
//---------------------------------------------------------------------------
//Quantile
float Quantile(float x)
{
    int denominator=5;
    float precision=0.0001;
    float step=1;
    int direction;
    int prev_dir=0;
    float quantile=0;

    while(step>precision){
        if(x<CDF(quantile)){direction=-1;}
        if(x>CDF(quantile)){direction=1;}

        quantile+=direction*step;
        if(prev_dir==0){
            prev_dir=direction;
            continue;
        }
        if(prev_dir!=direction){step/=denominator;}
        prev_dir=direction;
    }
    return quantile;
}

//Cumulative distribution function
float CDF(float x)
{
    float sum=0;
    float step=0.001;

    if(x<-4){return 0;}
    if(x>4){return 1;}

    for(float i=-4+step;i<=x;i+=step){
        sum+=exp(-0.5*pow((i-0.5*step),2))*step;
    }
    return sum/sqrt(2*M_PI);
}

